
void _eldbus_model_proxy_object_set(Eo *obj, Eldbus_Model_Proxy_Data *pd, Eldbus_Object *object);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(eldbus_model_proxy_object_set, EFL_FUNC_CALL(object), Eldbus_Object *object);

void _eldbus_model_proxy_interface_set(Eo *obj, Eldbus_Model_Proxy_Data *pd, const Eldbus_Introspection_Interface *interface);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(eldbus_model_proxy_interface_set, EFL_FUNC_CALL(interface), const Eldbus_Introspection_Interface *interface);

const char *_eldbus_model_proxy_proxy_name_get(const Eo *obj, Eldbus_Model_Proxy_Data *pd);


static Eina_Value
__eolian_eldbus_model_proxy_proxy_name_get_reflect(const Eo *obj)
{
   const char *val = eldbus_model_proxy_name_get(obj);
   return eina_value_string_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(eldbus_model_proxy_name_get, const char *, NULL);

Efl_Object *_eldbus_model_proxy_efl_object_constructor(Eo *obj, Eldbus_Model_Proxy_Data *pd);


Efl_Object *_eldbus_model_proxy_efl_object_finalize(Eo *obj, Eldbus_Model_Proxy_Data *pd);


void _eldbus_model_proxy_efl_object_invalidate(Eo *obj, Eldbus_Model_Proxy_Data *pd);


void _eldbus_model_proxy_efl_object_destructor(Eo *obj, Eldbus_Model_Proxy_Data *pd);


Eina_Iterator *_eldbus_model_proxy_efl_model_properties_get(const Eo *obj, Eldbus_Model_Proxy_Data *pd);


Eina_Future *_eldbus_model_proxy_efl_model_property_set(Eo *obj, Eldbus_Model_Proxy_Data *pd, const char *property, Eina_Value *value);


Eina_Value *_eldbus_model_proxy_efl_model_property_get(const Eo *obj, Eldbus_Model_Proxy_Data *pd, const char *property);


Eina_Future *_eldbus_model_proxy_efl_model_children_slice_get(Eo *obj, Eldbus_Model_Proxy_Data *pd, unsigned int start, unsigned int count);


unsigned int _eldbus_model_proxy_efl_model_children_count_get(const Eo *obj, Eldbus_Model_Proxy_Data *pd);


static Eina_Bool
_eldbus_model_proxy_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef ELDBUS_MODEL_PROXY_EXTRA_OPS
#define ELDBUS_MODEL_PROXY_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(eldbus_model_proxy_object_set, _eldbus_model_proxy_object_set),
      EFL_OBJECT_OP_FUNC(eldbus_model_proxy_interface_set, _eldbus_model_proxy_interface_set),
      EFL_OBJECT_OP_FUNC(eldbus_model_proxy_name_get, _eldbus_model_proxy_proxy_name_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _eldbus_model_proxy_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _eldbus_model_proxy_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _eldbus_model_proxy_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_destructor, _eldbus_model_proxy_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_model_properties_get, _eldbus_model_proxy_efl_model_properties_get),
      EFL_OBJECT_OP_FUNC(efl_model_property_set, _eldbus_model_proxy_efl_model_property_set),
      EFL_OBJECT_OP_FUNC(efl_model_property_get, _eldbus_model_proxy_efl_model_property_get),
      EFL_OBJECT_OP_FUNC(efl_model_children_slice_get, _eldbus_model_proxy_efl_model_children_slice_get),
      EFL_OBJECT_OP_FUNC(efl_model_children_count_get, _eldbus_model_proxy_efl_model_children_count_get),
      ELDBUS_MODEL_PROXY_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"proxy_name", NULL, __eolian_eldbus_model_proxy_proxy_name_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _eldbus_model_proxy_class_desc = {
   EO_VERSION,
   "Eldbus.Model.Proxy",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Eldbus_Model_Proxy_Data),
   _eldbus_model_proxy_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(eldbus_model_proxy_class_get, &_eldbus_model_proxy_class_desc, ELDBUS_MODEL_CLASS, NULL);
